<?php

// set error reporting level
if (version_compare(phpversion(), '5.3.0', '>=') == 1)
  error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED);
else
  error_reporting(E_ALL & ~E_NOTICE);

$aStations = array(
    0 => array(
  //0 = radio_dir/media/1.png
        'category' => 11,
        'name' => 'Radio Ice',
        'desc' => 'The Best Hits All Day Long',
        'url' => 'http://www.radio-ice.com',
        'br' => 128,
        'stream' => 'http://stream.zenolive.com/2m26re3dpg5tv'
    ),
    1 => array (
  //1 = radio_dir/media/2.png    
        'category' => 11,
        'name' => 'BBC2',
        'desc' => 'BBC - Radio 2',
        'url' => 'https://www.bbc.co.uk/radio2',
        'br' => 96,
        'stream' => 'http://bbcmedia.ic.llnwd.net/stream/bbcmedia_radio2_mf_p'
    ),
    2 => array (
  //2 = radio_dir/media/3.png 
        'category' => 401,
        'name' => 'WMAL',
        'desc' => 'WMAL is an online broadcast radio station in Washington, DC, United States, providing News and Talk Radio on In Washington, DC on WMAL 630 AM and to Woodbridge, Virginia, United States on WMAL-FM 105.9 FM. WMAL 105.9',
        'url' => 'http://www.wmal.com',
        'br' => 96,
        'stream' => 'http://17993.live.streamtheworld.com/WMALFM.mp3'
    ),
    3 => array (
  //3 = radio_dir/media/4.png
        'category' => 401,
        'name' => 'Internet Of Music',
        'desc' => 'Music is the answer, internetofmusic.com, #We stream underground.',
        'url' => 'https://www.internetofmusic.com',
        'br' => 96,
        'stream' => 'http://radio.internetofmusic.com:8000/live.nsv'
    )
);

function searchByCat($iCat, $aStations) {
    $aRes = array();
    foreach ($aStations as $i => $aInfo) {
        if ($aInfo['category'] == $iCat) {
            $aRes[$i] = $aInfo;
        }
    }
    return $aRes;
}
function searchByKeyword($sKey, $aStations) {
    $aRes = array();
    foreach ($aStations as $i => $aInfo) {
        if (false !== strpos($aInfo['name'], $sKey) || false !== strpos($aInfo['desc'], $sKey)) {
            $aRes[$i] = $aInfo;
        }
    }
    return $aRes;
}

function parseStationList($aData) {
    $sStations = '';
    if (is_array($aData) && count($aData) > 0) {
        foreach ($aData as $i => $a) {
            $sStationId = $i;
            $sStationBr = (int)$a['br'];
            $sStationName = $a['name'];
            $sStationDesc = $a['desc'];
            $sStationUrl = $a['url'];

            $sThumb = 'media/'.($sStationId+1).'.png';
            $sStations .= <<<EOF
<li>
    <a href="{$sStationId}" onclick="return play('{$sStationId}'); return false;"><img alt="{$sStationName}" src="{$sThumb}" title="{$sStationName}"></a>
    <div class="i">
        <p>Bitrate: {$sStationBr}</p>
    </div>
    <p class="channel"><a href="{$sStationId}" onclick="return play('{$sStationId}'); return false;">{$sStationName}</a></p>
    <p class="track">{$sStationDesc}</p>
    <p class="label">{$sStationUrl}</p>
</li>
EOF;
        }
    }
    $sStations = ($sStations == '') ? '<li>Nothing found</li>' : $sStations;
    return '<ul>' . $sStations . '</ul>';
}

switch ($_GET['action']) {
    case 'play':
        $i = (int)$_GET['id'];

        $aInfo = $aStations[$i];
        $aVars = array (
            '__stream__' => $aInfo['stream'],
            '__title__' => $aInfo['name']
        );
        echo strtr(file_get_contents('templates/radio.html'), $aVars); exit;
        break;
    case 'get_genre_stations':
        $i = (int)$_GET['id'];

        $aSearch = searchByCat($i, $aStations);

        $sStations = parseStationList($aSearch);
        header('Content-Type: text/html; charset=utf-8');
        echo $sStations; exit;
        break;
    case 'get_keyword_stations':
        $sKey = $_GET['key'];

        $aSearch = searchByKeyword($sKey, $aStations);

        $sStations = parseStationList($aSearch);
        header('Content-Type: text/html; charset=utf-8');
        echo $sStations; exit;
        break;
}

$sLastStations = parseStationList($aStations);
echo strtr(file_get_contents('templates/main_page.html'), array('__stations__' => $sLastStations));